#!/bin/bash

## $Workfile: postconfig-static.sh$
## $DateUTC: 2007-04-09 15:49:28Z$
# To reduce the number of target prerequisites selectively static link all but
# the base system libraries (libpthread,libdl,libm,libc,etc.). Doing this will
# enable the use of Real binary codecs drvc.so and atrc.so.6.0 (and potentially
# others). Linking statically (via --enable-static) will cause the dlopen for
# each of these to fail due to their implicit dependencies on libpthread and
# libdl, respectively. Dynamically linking these libraries allows for the
# symbols to be pulled in from the mencoder binary.

file=config.mak
[ -f $file ] || { echo "$0: $file not found! Have you run configure?"; exit 1; }
echo "$0: patching $file"

#1) assume -lpthread indicates the beginning of system libraries (e.g. -lm -ldl, etc)
#   pull all leading libraries in statically, base system libs dynamically
#2) remove -static added by --enable-static
#3) pull all EXTRALIBS in statically...
#4-6) ...except libpthread,libdl or libm
sed -i\
	-e's/\(EXTRA_LIB\s\+=\)\(.*\)-lpthread/\1-Wl,-Bstatic \2 -Wl,-Bdynamic -lpthread/g'\
	-e's/-static//g'\
	-e's/\(EXTRALIBS.*=\)\(.*\)/\1-Wl,-Bstatic \2 -Wl,-Bdynamic/g'\
	-e's/\(EXTRALIBS.*=.*\)-lpthread\b/\1/g'\
	-e's/\(EXTRALIBS.*=.*\)-lm\b/\1/g'\
	-e's/\(EXTRALIBS.*=.*\)-ldl\b/\1/g'\
	$file
